var _excluded = ["variant", "badgeSize"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import { Icon } from '../../../..';
import { IconBadge } from '..';
import { MAP_BADGE_AND_ICON_SIZES, MAP_ICON_COMPONENT_NAME, VARIANT_CREATE, ICON_COLOR, VARIANT_COMPLETE, VARIANT_PENDING, VARIANT_ERROR, VARIANT_WARNING, VARIANT_INFORMATION } from './StatusBadge.constants';
var getStatusBadgeProps = function getStatusBadgeProps(variant, badgeSize) {
  var sizes = MAP_BADGE_AND_ICON_SIZES[badgeSize];
  var iconBaseName = MAP_ICON_COMPONENT_NAME[variant];
  var iconComponentName = "".concat(iconBaseName).concat(sizes.iconSize);
  var IconComponent = Icon[iconComponentName];
  switch (variant) {
    case VARIANT_CREATE:
      return {
        icon: React.createElement(IconComponent, {
          color: ICON_COLOR
        }),
        badgeColor: function badgeColor(t) {
          return t.color.badgeBackground;
        },
        badgeSize: sizes.badgeSize
      };
    case VARIANT_COMPLETE:
      return {
        icon: React.createElement(IconComponent, {
          color: ICON_COLOR
        }),
        badgeColor: function badgeColor(t) {
          return t.color.badgeBackgroundPositive;
        },
        badgeSize: sizes.badgeSize
      };
    case VARIANT_PENDING:
      return {
        icon: React.createElement(IconComponent, {
          color: ICON_COLOR
        }),
        badgeColor: function badgeColor(t) {
          return t.color.badgeBackgroundWarning;
        },
        badgeSize: sizes.badgeSize
      };
    case VARIANT_ERROR:
      return {
        icon: React.createElement(IconComponent, {
          color: ICON_COLOR
        }),
        badgeColor: function badgeColor(t) {
          return t.color.badgeBackgroundNegative;
        },
        badgeSize: sizes.badgeSize
      };
    case VARIANT_WARNING:
      return {
        icon: React.createElement(IconComponent, {
          color: ICON_COLOR
        }),
        badgeColor: function badgeColor(t) {
          return t.color.badgeBackgroundWarning;
        },
        badgeSize: sizes.badgeSize
      };
    case VARIANT_INFORMATION:
      return {
        icon: React.createElement(IconComponent, {
          color: ICON_COLOR
        }),
        badgeColor: function badgeColor(t) {
          return t.color.badgeBackground;
        },
        badgeSize: sizes.badgeSize
      };
    default:
      return {
        icon: React.createElement(IconComponent, {
          color: ICON_COLOR
        }),
        badgeColor: function badgeColor(t) {
          return t.color.badgeBackground;
        },
        badgeSize: sizes.badgeSize
      };
  }
};
export var StatusBadge = React.forwardRef(function (_ref, ref) {
  var _ref$variant = _ref.variant,
    variant = _ref$variant === void 0 ? 'information' : _ref$variant,
    _ref$badgeSize = _ref.badgeSize,
    badgeSize = _ref$badgeSize === void 0 ? 'l' : _ref$badgeSize,
    htmlProps = _objectWithoutProperties(_ref, _excluded);
  var statusBadgeProps = getStatusBadgeProps(variant, badgeSize);
  return React.createElement(IconBadge, _extends({}, htmlProps, {
    ref: ref,
    badgeSize: statusBadgeProps.badgeSize,
    badgeColor: statusBadgeProps.badgeColor
  }), statusBadgeProps.icon);
});